DVBCWNS5 ;VMP/JER - SPINE WKS TEXT - 1 ; 12/02/03 11:00am
 ;;2.7;AMIE;**60**;DEC 2, 2003
        ;
TXT     ;
        ;;
        ;;A. Review of Medical Records:
        ;;
        ;;B. Present Medical History (Subjective Complaints):
        ;;
        ;;Please comment whether etiology for any of these subjective complaints is
        ;;unrelated to claimed disability.
        ;;
        ;;1.    Report complaints of pain (including any radiation), stiffness,
        ;;      weakness, etc. 
        ;;       a.     Onset 
        ;;       b.     Location and distribution 
        ;;       c.     Duration 
        ;;       d.     Characteristics, quality, description 
        ;;       e.     Intensity 
        ;;2.    Describe treatment - type, dose, frequency, response, side effects. 
        ;;3.    Report whether there are periods of flare-up. Provide the 
        ;;      following if individual reports periods of flare-up: 
        ;;       a.     Severity, frequency, and duration. 
        ;;       b.     Precipitating and alleviating factors. 
        ;;       c.     Additional limitation of motion or functional impairment during
        ;;              the flare-up. 
        ;;4.    Describe associated features or symptoms (e.g., weight loss, fevers,
        ;;      malaise, dizziness, visual disturbances, numbness, weakness,
        ;;      bladder complaints, bowel complaints, erectile dysfunction). 
        ;;5.    Describe walking and assistive devices. 
        ;;       a.     Does the veteran walk unaided? Does the veteran use a cane,
        ;;              crutches, or a walker? 
        ;;       b.     Does the veteran use a brace (orthosis)? 
        ;;       c.     How far and how long can the veteran walk? 
        ;;       d.     Is the veteran unsteady? Does the veteran have a history of
        ;;              falls? 
        ;;6.    Describe details of any trauma or injury, including dates, and direction
        ;;      and magnitude of forces. 
        ;;7.    Describe details of any surgery, including dates. 
        ;;8.    Functional Assessment - Describe effects of the condition(s) on the
        ;;      veteran's mobility (e.g., walking, transfers), activities of daily
        ;;      living (i.e., eating, grooming, bathing, toileting, dressing), usual
        ;;      occupation, recreational activities, driving. 
        ;;
        ;;C. Physical Examination (Objective Findings): Address each of the following as 
        ;;   appropriate to the condition being examined and fully describe current
        ;;   findings:
        ;; 
        ;;       1.      Inspection: spine, limbs, posture and gait, position of the
        ;;        head, curvatures of the spine, symmetry in appearance, symmetry
        ;;        and rhythm of spinal motion.
        ;;
        ;;       2.      Range of motion
        ;;
        ;;       a.      Cervical Spine 
        ;;
        ;;               The reproducibility of an individual's range of motion is one
        ;;        indicator of optimum effort. Pain, fear of injury, disuse or
        ;;        neuromuscular inhibition may limit mobility by decreasing the
        ;;        individual's effort. If range of motion measurements fail to
        ;;        match known pathology, please repeat the measurements.
        ;;        (Reference: Guides to the Evaluation of Permanent Impairment,
        ;;        Fifth Edition, 2001, page 399).
        ;; 
        ;;           i. Using a goniometer, measure and report the range of motion in
        ;;              degrees of forward flexion, extension, left lateral flexion,
        ;;              right lateral flexion, left lateral rotation and right lateral
        ;;              rotation. Generally, the normal ranges of motion for the
        ;;              cervical spine are as follows:
        ;; 
        ;;              -Forward flexion: 0 to 45 degrees 
        ;;              -Extension: 0 to 45 degrees 
        ;;              -Left Lateral Flexion: 0 to 45 degrees 
        ;;              -Right Lateral Flexion: 0 to 45 degrees 
        ;;              -Left Lateral Rotation: 0 to 80 degrees 
        ;;              -Right Lateral Rotation: 0 to 80 degrees
        ;;
        ;;      There may be a situation where an individual's range of motion is
        ;;      reduced, but "normal" (in the examiner's opinion) based on the
        ;;      individual's age, body habitus, neurologic disease, or other factors
        ;;      unrelated to the disability for which the exam is being performed. In
        ;;      this situation, please explain why the individual's measured range of
        ;;      motion should be considered as "normal".
        ;;
        ;;          ii. If the spine is painful on motion, state at what point in the
        ;;              range of motion pain begins and ends. 
        ;;
        ;;         iii. State to what extent (if any), expressed in degrees if
        ;;              possible, the range of motion is additionally limited by pain,
        ;;              fatigue, weakness, or lack of endurance following repetitive use
        ;;              or during flare-ups. If more than one of these is present, 
        ;;              state, if possible, which has the major functional impact.
        ;;
        ;;          iv. Describe objective evidence of painful motion, spasm, weakness,
        ;;              tenderness, etc.
        ;; 
        ;;           v. Describe any postural abnormalities, fixed deformity
        ;;              (ankylosis), or abnormality of musculature of cervical spine
        ;;              musculature. In the situation where there is unfavorable
        ;;              ankylosis of the cervical spine, indicate whether there is:
        ;;              difficulty walking because of a limited line of vision;
        ;;              restricted opening of the mouth (with limited ability to 
        ;;              chew); breathing limited to diaphragmatic respiration;
        ;;              gastrointestinal symptoms due to pressure of the costal margin
        ;;              on the abdomen; dyspnea; dysphagia; atlantoaxial or cervical
        ;;              subluxation or dislocation 
        ;;
        ;;
        ;;      b. Thoracolumbar spine 
        ;;
        ;;              The reproducibility of an individual's range of motion is one
        ;;              indicator of optimum effort. Pain, fear of injury, disuse or
        ;;              neuromuscular inhibition may limit mobility by decreasing the
        ;;              individual's effort. If range of motion measurements fail to
        ;;              match known pathology, please repeat the measurements.
        ;;              (Reference: Guides to the Evaluation of Permanent Impairment,
        ;;              Fifth Edition, 2001, page 399).
        ;; 
        ;;              It is best to measure range of motion for the thoracolumbar
        ;;              spine from a standing position. Measuring the range of motion
        ;;              from a standing position (as opposed to from a sitting position)
        ;;              will include the effects of forces generated by the distance
        ;;              from the center of gravity from the axis of motion of the spine
        ;;              and will include the effect of contraction of the spinal
        ;;              muscles. Contraction of the spinal muscles imposes a significant
        ;;              compressive force during spine movements upon the lumbar discs.
        ;;
        ;;           i. Provide forward flexion of the thoracolumbar spine as a unit.
        ;;              Do not include hip flexion. (See Magee, Orthopedic Physical
        ;;              Assessment, Third Edition, 1997, W.B. Saunders Company,
        ;;              pages 374-75). Using a goniometer, measure and report the range
        ;;              of motion in degrees for forward flexion, extension, left 
        ;;              lateral flexion, right lateral flexion, left lateral rotation
        ;;              and right lateral rotation. Generally, the normal ranges of 
        ;;              motion for the thoracolumbar spine as a unit are as follows:
        ;;
        ;;  -Forward flexion: 0 to 90 degrees 
        ;;  -Extension: 0 to 30 degrees 
        ;;  -Left Lateral Flexion: 0 to 30 degrees 
        ;;  -Right Lateral Flexion: 0 to 30 degrees 
        ;;  -Left Lateral Rotation: 0 to 30 degrees 
        ;;  -Right Lateral Rotation: 0 to 30 degrees
        ;; 
        ;;There may be a situation where an individual's range of motion is reduced, but 
        ;;"normal" (in the examiner's opinion) based on the individual's age, body 
        ;;habitus, neurologic disease, or other factors unrelated to the disability for
        ;;which the exam is being performed. In this situation, please explain why the
        ;;individual's measured range of motion should be considered as "normal".
        ;; 
        ;;       ii. If the spine is painful on motion, state at what point in the range 
        ;;           of motion pain begins and ends.
        ;; 
        ;;      iii. State to what extent (if any), expressed in degrees if possible,
        ;;           the range of motion is additionally limited by pain, fatigue,
        ;;           weakness, or lack of endurance following repetitive use or during
        ;;           flare-ups. If more than one of these is present, state, if possible,
        ;;           which has the major functional impact.
        ;; 
        ;;       iv. Describe objective evidence of painful motion, spasm, weakness,
        ;;           tenderness, etc.
        ;; 
        ;;           a. Indicate whether there is muscle spasm, guarding or localized
        ;;              tenderness with preserved spinal contour, and normal gait.
        ;; 
        ;;           b. Indicate whether there is muscle spasm, or guarding severe enough
        ;;              to result in an abnormal gait, abnormal spinal contour such as
        ;;              scoliosis, reversed lordosis or abnormal kyphosis.
        ;; 
        ;;        v. Describe any postural abnormalities, fixed deformity (ankylosis), 
        ;;           or abnormality of musculature of back. In the situation where
        ;;           there is unfavorable ankylosis of the thoracolumbar spine,
        ;;           indicate whether there is: difficulty walking because of a
        ;;           limited line of vision; restricted opening of the mouth (with
        ;;           limited ability to chew); breathing limited to diaphragmatic
        ;;           respiration; gastrointestinal symptoms due to pressure of
        ;;           the costal margin on the abdomen; dyspnea; dysphagia; 
        ;;           atlantoaxial or cervical subluxation or dislocation; or
        ;;           neurologic symptoms due to nerve root involvement.
        ;;
        ;;          3. Neurological examination
        ;;
        ;;Please perform complete neurologic evaluation as indicated based upon
        ;;disability for which the exam is being performed. Please provide brief
        ;;statement if any of the following (a-e) is not included in exam. For
        ;;additional neurologic effects of disability not captured by a - e, 
        ;;(e.g. bladder problems) please refer to appropriate worksheet for the body
        ;;system affected.
        ;;
        ;;          a. Sensory examination, to include sacral segments. 
        ;;          b. Motor examination (atrophy, circumferential measurements, tone, 
        ;;             and strength). 
        ;;          c. Reflexes (deep tendon, cutaneous, and pathologic). 
        ;;          d. Rectal examination (sensation, tone, volitional control, and 
        ;;             reflexes). 
        ;;          e. Lasegue's sign.
        ;;
        ;;              4. For vertebral fractures, report the percentage of loss of
        ;;                 height, if any, of the vertebral body 
        ;;              5. Non-organic physical signs (e.g., Waddell tests, others).
        ;; 
        ;;D. For intervertebral disc syndrome
        ;;
        ;;              1. Conduct and report a separate history and physical
        ;;                 examination for each segment of the spine (cervical,
        ;;                 thoracic, lumbar) affected by disc disease. 
        ;;              2. Conduct a complete history and physical examination of each
        ;;                 affected segment of the spine (cervical, thoracic, lumbar),
        ;;                 whether or not there has been surgery, as described above
        ;;                 under B. Present Medical History and C. Physical Examination. 
        ;;              3. Conduct a thorough neurologic history and examination, as 
        ;;                 described in C5, of all areas innervated by each affected
        ;;                 spinal segment. Specify the peripheral nerve(s) affected.
        ;;                 Include an evaluation of effects, if any, on bowel or bladder
        ;;                 functioning. 
        ;;              4. Describe as precisely as possible, in number of days, the
        ;;                 duration of each incapacitating episode during the past 
        ;;                 12-month period. An incapacitating episode, for disability
        ;;                 evaluation purposes, is a period of acute signs and symptoms
        ;;                 due to intervertebral disc syndrome that requires bed rest
        ;;                 prescribed by a physician and treatment by a physician.
        ;;
        ;;E. Diagnostic and Clinical Tests:
        ;; 
        ;;  1. Imaging studies, when indicated. 
        ;;  2. Electrodiagnostic tests, when indicated. 
        ;;  3. Clinical laboratory tests, when indicated. 
        ;;  4. Isotope scans, when indicated. 
        ;;  5. Include results of all diagnostic and clinical tests conducted in the
        ;;     examination report.
        ;; 
        ;;F. Diagnosis:
        ;;
        ;; 
        ;;Signature:                                    Date:
 ;;END
